var VPPSClass = function() {}

VPPSClass.prototype.showMenu = function(menu) {
	var children = menu.childNodes;
	for (var x = children.length-1; x >= 0; x--) {
		menu.removeChild(children[x]);
	}
	var doc;
	//var stringBundle = document.getElementById('vpps_stringbundle');
	var stringBundle = srGetStrBundle("chrome://vpps/locale/vpps.properties");
	var showsourcemenu = document.createElement('menuitem');
	if (!gContextMenu || !gContextMenu.inFrame) {
		showsourcemenu.setAttribute("label", stringBundle.GetStringFromName("menu.viewformattedsource.name"));
		
		doc = window.content;
	}
	else {
		showsourcemenu.setAttribute("label", stringBundle.GetStringFromName("menu.viewformattedframesetsource.name"));			
		//doc=document.commandDispatcher.focusedWindow.content;	
		doc=document.commandDispatcher.focusedWindow;
		maindoc=window.content;
	}
	showsourcemenu.setAttribute("acceltext",stringBundle.GetStringFromName("menu.viewformattedsource.accel"));
	showsourcemenu.setAttribute("oncommand", "VPPSObject.doPrettyPrint('maindoc');");
	if (gContextMenu && gContextMenu.inFrame) {
		if (!doc.document.getElementById('__vpps_0')) {
			inlinemode = document.createElement('menuitem');
		  inlinemode.setAttribute("label", stringBundle.GetStringFromName("menu.enableinlinemodeonframe.name"));
		  inlinemode.setAttribute("oncommand", "VPPSObject.doInlineMode('frame');");
		  menu.appendChild(inlinemode);	  	  
		} else {
			inlinemoder = document.createElement('menuitem');
		  inlinemoder.setAttribute("label", stringBundle.GetStringFromName("menu.disableinlinemodeonframe.name"));
		  inlinemoder.setAttribute("oncommand", "VPPSObject.removeInlineMode('frame');");
		  menu.appendChild(inlinemoder);	  	  
		}
		if (!maindoc.document.getElementById('__vpps_0')) {
		  inlinemodef = document.createElement('menuitem');
		  inlinemodef.setAttribute("label", stringBundle.GetStringFromName("menu.enableinlinemodeonframeset.name"));
		  inlinemodef.setAttribute("oncommand", "VPPSObject.doInlineMode('maindoc');");
		  menu.appendChild(inlinemodef);	  	  
		} else {			
			inlinemodefr = document.createElement('menuitem');
		  inlinemodefr.setAttribute("label", stringBundle.GetStringFromName("menu.disableinlinemodeonframeset.name"));
		  inlinemodefr.setAttribute("oncommand", "VPPSObject.removeInlineMode('maindoc');");
		  menu.appendChild(inlinemodefr);	  	  
		}
	} else
	if (!gContextMenu || !gContextMenu.inFrame) {
		if (!doc.document.getElementById('__vpps_0')) {
			var inlinemode = document.createElement('menuitem');
		  inlinemode.setAttribute("label", stringBundle.GetStringFromName("menu.enableinlinemode.name"));
		  inlinemode.setAttribute("oncommand", "VPPSObject.doInlineMode('maindoc');");
		  menu.appendChild(inlinemode);		
		} else {
			var inlinemoderem = document.createElement('menuitem');
		  inlinemoderem.setAttribute("label", stringBundle.GetStringFromName("menu.disableinlinemode.name"));
		  inlinemoderem.setAttribute("oncommand", "VPPSObject.removeInlineMode('maindoc');");
		  menu.appendChild(inlinemoderem);		
		}
	}
		
	menu.appendChild(showsourcemenu);
	if (gContextMenu && gContextMenu.inFrame) {
		showsourcemenu = document.createElement('menuitem');
	  showsourcemenu.setAttribute("label", stringBundle.GetStringFromName("menu.viewformattedframesource.name"));
	  showsourcemenu.setAttribute("oncommand", "VPPSObject.doPrettyPrint('frame');");
	  menu.appendChild(showsourcemenu);	  
	}
	if (gContextMenu && gContextMenu.isTextSelected==true) {
		showselectedsourcemenu = document.createElement('menuitem');
	  showselectedsourcemenu.setAttribute("label", stringBundle.GetStringFromName("menu.viewformattedselection.name"));
	  showselectedsourcemenu.setAttribute("oncommand", "VPPSObject.doPrettyPrint('selection');");
	  menu.appendChild(showselectedsourcemenu);	  
	}
	var optionsmenu = document.createElement('menuitem');
	optionsmenu.setAttribute("label", stringBundle.GetStringFromName("menu.options.name"));
	optionsmenu.setAttribute("oncommand",'window.openDialog("chrome://vpps/content/options.xul", "'+stringBundle.GetStringFromName("menu.options.name")+'", "chrome,dialog=1,left=30,top=30");');
	menu.appendChild(optionsmenu);
}


VPPSClass.prototype.isBlockElement = function(node) {
	//return (node.tagName=="HEAD" || node.tagName=="UL" || node.tagName=="OL" || node.tagName=="DL" || node.tagName=="MAP" || node.tagName=="P" || node.tagName=="FONT" || node.tagName=="NOSCRIPT" || node.tagName=="BODY" || node.tagName=="TABLE" || node.tagName=="TR" || node.tagName=="TD" || node.tagName=="TH" || node.tagName=="DIV" || node.tagName=="SPAN" || node.tagName=="SCRIPT" || node.tagName=="FORM" || node.tagName=="SELECT");
	for (var x=0;x<this.formattingarray.length;x++) {
		if (this.formattingarray[x]==node.tagName) return true;
	}
	return false;
}

VPPSClass.prototype.printNode = function(node, target) {
		this.currenttag = node.tagName;
		var bluefont = target.ownerDocument.importNode(this.bluefontprototype, false);
		var attributes = node.attributes;
		var textnode;
		
		if (attributes.length==0)
			textnode = target.ownerDocument.createTextNode("<"+node.tagName.toLowerCase()+">");
		else
			textnode = target.ownerDocument.createTextNode("<"+node.tagName.toLowerCase());	
		if (this.isBlockElement(node)) {
			link=target.ownerDocument.importNode(this.hoverlinkprototype, false);			
			link.setAttribute("_vpps_id",this.blocknr);
			link.appendChild(textnode);			
			if (this.showcssinfo==true) {				
				link.setAttribute("onMouseOver","hilite(this.getAttribute('_vpps_id'));showStyle('"+this.computeStyle(node)+"',event);");
				link.setAttribute("onMouseOut","lolite(this.getAttribute('_vpps_id'));hideStyle();");				
				link.setAttribute("onClick","toggleStickiness();");
			}
			//link.setAttribute("onClick","alert('"+this.computeStyle(node)+"');");			
			bluefont.appendChild(link);
		}	else
		if (node.tagName == 'IMG') {
			var value=node.src;		
			if (value.indexOf('://')==-1) {
				if (value.charAt(0) != '/') slash=this.pathname; else slash="";
				value=this.hostname+slash+value;
			}
			link=target.ownerDocument.importNode(this.controldivprototype, false);
			link.setAttribute("imgsrc", value);
			if (this.showcssinfo==true) {
				link.setAttribute("onMouseOver","showimg(this.getAttribute('imgsrc'));showStyle('"+this.computeStyle(node)+"',event)");
				link.setAttribute("onMouseOut","hideimg();hideStyle();");
			}
			link.appendChild(textnode);			
			bluefont.appendChild(link);
			
			//link="<a style=\"text-decoration:none\" onmouseover=\"showimg('"+code+"');\" onmouseout=\"hideimg();\" href=\"javascript:void();\">";
		
		} else {
			if (this.showcssinfo==true) {
				link = target.ownerDocument.createElement('a');
				link.setAttribute("onMouseOver","showStyle('"+this.computeStyle(node)+"',event)");
				link.setAttribute("onClick","toggleStickiness();");
				link.setAttribute("onMouseOut","hideStyle();");
				link.appendChild(textnode);
				bluefont.appendChild(link);		
			} else bluefont.appendChild(textnode);
		}
		if (attributes.length>0) {
			for (var nc=0;nc<attributes.length;nc++) {
				var redfont = target.ownerDocument.importNode(this.redfontprototype, false);
				redfont.appendChild(target.ownerDocument.createTextNode(" "+attributes[nc].name+"="));
				var blackfont = target.ownerDocument.importNode(this.blackfontprototype, false);
				var att = attributes[nc].value;
				for (var c=0;c<5;c++) {					
					if (node.tagName != 'A' || this.specialchar[c] != "/&/g")
						att = att.replace(this.specialchar[c],"&"+this.replacements[c]);
				}
				if (attributes[nc].name=='style') att = this.replaceWithHexValues(att);
				blackfont.appendChild(target.ownerDocument.createTextNode("\""+att+"\""));
				bluefont.appendChild(redfont);
				bluefont.appendChild(blackfont);
			}
			bluefont.appendChild(target.ownerDocument.createTextNode(">"));		
		}
  	var div = target.ownerDocument.createElement('div');
  	div.style.margin="0px 0px 0px "+this.indent*10+"px";
		div.appendChild(bluefont);		
		if (this.showexternalscripts && node.tagName == 'SCRIPT' && node.src != undefined && node.src != '') {		
			var iframe = target.ownerDocument.createElement('iframe');
			iframe.setAttribute('width',900);
			iframe.height=270;
			iframe.setAttribute('style','background-color:#ffffcc');
			var value=node.src;		
			if (value.indexOf('://')==-1) {
				if (value.charAt(0) != '/') slash=this.pathname; else slash="";
				value=this.hostname+slash+value;
			}
			iframe.setAttribute('src',value);			
			iframe.setAttribute('frameborder',0);
			div.appendChild(target.ownerDocument.createElement('br'));
			div.appendChild(iframe);
			div.appendChild(target.ownerDocument.createElement('br'));
		} 
		if (this.showexternalscripts && node.tagName == 'LINK' && node.href != undefined && node.href != '' && node.rel=="stylesheet") {		
			var iframe = target.ownerDocument.createElement('iframe');
			iframe.setAttribute('width',900);
			iframe.height=270;
			iframe.setAttribute('style','background-color:#ffffcc');
			var value=node.href;		
			if (value.indexOf('://')==-1) {
				if (value.charAt(0) != '/') slash=this.pathname; else slash="";
				value=this.hostname+slash+value;
			}
			iframe.setAttribute('src',value);			
			iframe.setAttribute('frameborder',0);
			div.appendChild(target.ownerDocument.createElement('br'));
			div.appendChild(iframe);
			div.appendChild(target.ownerDocument.createElement('br'));
		}		
		if (this.isBlockElement(node)) {
			var controldiv = target.ownerDocument.importNode(this.controldivprototype, false);
			var link = target.ownerDocument.importNode(this.foldiconlinkprototype, false);
			link.setAttribute('blocknr',this.blocknr);
			var image = target.ownerDocument.createElement('img');
			image.setAttribute("src", "chrome://vpps/skin/minus.png");
			image.setAttribute("border","0");
			link.appendChild(image);			
			controldiv.id = "con_"+this.blocknr;			
			controldiv.appendChild(link);
			target.appendChild(controldiv);
			var blockdiv = target.ownerDocument.createElement('div');
			blockdiv.setAttribute("_vpps_id",this.blocknr);
			blockdiv.id = this.blocknr;
			blockdiv.setAttribute("containedTag", node.tagName);
			blockdiv.appendChild(div);
			target.appendChild(blockdiv);
			this.blocknr++;
			return blockdiv;
		} else {
			target.appendChild(div);		
			return target;
		}
	}
	
VPPSClass.prototype.hasEndTag = function(node) {
	return !(node.tagName=="IMG" || node.tagName=="INPUT" || node.tagName=="BR");
}
	
VPPSClass.prototype.printFinalNode = function(node, target) {
	if (!this.hasEndTag(node)) return target;
		var bluefont = target.ownerDocument.importNode(this.bluefontprototype, false);
		if (this.isBlockElement(node)) {
			var id = target.getAttribute("_vpps_id");			
			var link=target.ownerDocument.importNode(this.hoverlinkprototype, false);			
			link.setAttribute("_vpps_id",id);
			link.appendChild(target.ownerDocument.createTextNode("</"+node.tagName.toLowerCase()+">"));
			bluefont.appendChild(link);
		} else
			bluefont.appendChild(target.ownerDocument.createTextNode("</"+node.tagName.toLowerCase()+">"));		
		var div2 = target.ownerDocument.createElement('div');
 		div2.style.margin="0px 0px 0px "+this.indent*10+"px";
		div2.appendChild(bluefont);
		target.appendChild(div2);	
		if (this.isBlockElement(node)) {
			return target.parentNode;			
		} else
			return target;					
	}
	
	
	VPPSClass.prototype.trimText = function(text) {
		return text.replace(/^\s+|\s+$/gm,this.invisiblecharreplacement); // why is regexp faster???
/*
		var beginning=-1;
		for (c=0;c<text.length;c++) {
			var ch = text.charCodeAt(c);			
			if (ch>32) {
				beginning=c;
				break;
			}
		}
		var ending=-1;
		if (beginning!=-1) {
			for (c=text.length;c>0;c--) {
				var ch = text.charCodeAt(c);			
				if (ch>32) {
					ending=c;				
					break;
				}
			}		
		} else return "";
	if (ending==-1 || beginning==-1) return ""; else
	if (beginning==0 && ending==text.length-1) return text; else return text.substring(beginning, ending+1);*/
	}
	
	VPPSClass.prototype.printComment = function(text, target) {		
		var table = target.ownerDocument.importNode(this.commenttableprototype, true);
		var textnode = target.ownerDocument.createTextNode("<!-- "+text+" -->");
		table.firstChild.firstChild.appendChild(textnode);
		var div2 = target.ownerDocument.createElement("div");
 		div2.style.margin="0px 0px 0px "+this.indent*10+"px";
		div2.appendChild(table);
		target.appendChild(div2);
	}
	
	VPPSClass.prototype.printSimpletext = function(text, target) {
		if (this.currenttag != 'PRE') text = this.trimText(text);
		if (text.length<=0) return;
		var table = target.ownerDocument.importNode(this.texttableprototype, true);		
		if (this.currenttag != 'SCRIPT' && this.currenttag != 'STYLE' && this.currenttag != 'NOSCRIPT') {
			for (var c=0;c<5;c++) {
				//text = text.split(this.specialchar[c]);
				//text = text.join("&"+this.replacements[c]);			
				text = text.replace(this.specialchar[c],"&"+this.replacements[c]);
			}
			//text = text.replace(/&/g,"&amp;");
		}
		var textnode = target.ownerDocument.createTextNode(text);
		table.firstChild.firstChild.firstChild.appendChild(textnode);
		var div2 = target.ownerDocument.createElement("div");
 		div2.style.margin="0px 0px 0px "+this.indent*10+"px";
		div2.appendChild(table);
		target.appendChild(div2);
	}
	
	VPPSClass.prototype.printChildren = function(node,target) {		
		var ntarget=target;
		for (var x=0;x<node.childNodes.length;x++) {			
			if (node.childNodes[x].nodeType == 3) {
				this.printSimpletext(node.childNodes[x].nodeValue, ntarget);				
			}
		  else
		  if (node.childNodes[x].nodeType == 8) {		  	
		  	this.printComment(node.childNodes[x].nodeValue, ntarget);  	
		  } else
		  if (node.childNodes[x].nodeType == 1) {
		  	var curnode = node.childNodes[x];		  	
		  	if (curnode.id.indexOf('__vpps_')!=-1) curnode = curnode.firstChild.nextSibling;		
				ntarget = this.printNode(curnode, ntarget);								
				if (curnode.hasChildNodes()) {
					++this.indent;
					ntarget = this.printChildren(curnode,ntarget);				
					--this.indent;
				}			
				ntarget = this.printFinalNode(curnode, ntarget);				
			}
		}
		return ntarget;
	}
	
	VPPSClass.prototype.createJavascriptFunctions = function() {
		return"<script type=\"text/javascript\">\n"+
		"function hilite(id) {\n"+		
		"document.getElementById(id).className='hilite';\n"+
		"}\n"+
		"function lolite(id) {\n"+
		"document.getElementById(id).className='';\n"+
		"}\n"+
		"function unfold(id) {\n"+
		"var blocklevelelement = document.getElementById(id);"+
		"var pluscont = document.createElement('div');"+
		"pluscont.setAttribute('style', blocklevelelement.firstChild.getAttribute('style'));"+		
		"pluscont.style.background='#eeeeee';"+
		"blocklevelelement.style.display='none';"+
		"pluscont.appendChild(document.createTextNode(\"<\"+blocklevelelement.getAttribute(\"containedTag\").toLowerCase()+\">...</\"+blocklevelelement.getAttribute(\"containedTag\").toLowerCase()+\">\"));"+
		"var inputfield = document.createElement('input');"+
		"inputfield.width='100';"+
		"pluscont.appendChild(inputfield);"+
		"blocklevelelement.parentNode.insertBefore(pluscont, blocklevelelement);"+
		"var controller = document.getElementById('con_'+id);"+
		"controller.innerHTML='<a href=\"javascript:fold(\\''+id+'\\')\"><img src=\"chrome://vpps/skin/plus.png\" border=\"0\"></a>'"+
		"}\n"+
		"function fold(id) {\n"+
		"var cont = document.getElementById(id);"+
		"cont.style.display='';"+
		"cont.parentNode.removeChild(cont.previousSibling);"+
		"var controller = document.getElementById('con_'+id);"+
		"controller.innerHTML='<a href=\"javascript:unfold(\\''+id+'\\')\"><img src=\"chrome://vpps/skin/minus.png\" border=\"0\"></a>'"+
		"}\n"+
		"function showimg(code) {\n"+
		"document.getElementById('previewimg').innerHTML='<table border=0 cellpadding=5><tr><td><img border=0 src=\"'+code+'\"></td></tr></table>';\n"+
		"document.getElementById('previewimg').style.top=document.body.scrollTop+5;\n"+
		"document.getElementById('previewimg').style.left=document.body.scrollLeft+100;\n"+
		"document.getElementById('previewimg').style.display='';\n"+
		"}\n"+
		"function showStyle(style,e) {\n"+
		"document.getElementById('styledata').innerHTML=style;\n"+
		"document.getElementById('styledata').style.top=e.pageY+5;\n"+
		"document.getElementById('styledata').style.left=e.pageX+5;\n"+
		"document.getElementById('styledata').style.display='';\n"+
		"if (!document.getElementById('styledata').getAttribute('sticky')) document.getElementById('styledata').setAttribute('sticky','false');\n"+
		"}\n"+
		"function hideStyle() {\n"+
		"if (!document.getElementById('styledata').getAttribute('sticky') || document.getElementById('styledata').getAttribute('sticky')=='false')\n"+
		"  document.getElementById('styledata').style.display='none';\n"+
		"}\n"+
		"function toggleStickiness() {\n"+
		"var issticky=false;var el = document.getElementById('styledata'); if (el.getAttribute('sticky')=='false') issticky=false; else issticky=true;\n"+
		"var newsticky='false'; if (issticky==false) newsticky='true';\n"+
		"el.setAttribute('sticky',newsticky);\n"+
		"if (issticky) hideStyle();\n"+
		"}\n"+
		"function hideimg() {\n"+
		"document.getElementById('previewimg').style.display='none';\n"+
		"}\n"+		
		"</scr"+"ipt>\n";
	}
	
	VPPSClass.prototype.createCSS = function() {
		return "<STYLE type=\"text/css\">\n"+
   		".hilite {background-color:#eeeeee}\n"+
   		".lolite {background-color:#ffffff}\n"+
   		"b { font-weight:normal;color:red }\n"+
   		"i { font-style:normal;color:blue }\n"+
   		"u { font-style:normal;color:black;text-decoration:none }\n"+   		
   		"a { font-style:normal;text-decoration:none; }\n"+   	
   		"pre { }\n"+	
   		"input { border-width:1px;border-style:solid;font-family:'Lucida Console', 'Courier New', Courier, monospace;font-size:11px; }\n"+
   		".cssheader { padding-left:2px;font-family:'Lucida Console', 'Courier New', Courier, monospace;font-size:11px;font-weight:bold;background-color:#0000D6;color:white;}\n"+
   		".csswindow { display:none;border:1px;border-style:solid;background-color:#ffff99;position:absolute;top:5px;left:5px; }\n"+
   		".csstext { font-size:11px;color:black; }\n"+
 			"</STYLE>";
	}
	
function VPPS_getFormattingArray() {

	var formatelements = new Array("col_head"
,"col_body"
,"col_div"
,"col_span"
,"col_p"
,"col_font"
,"col_map"
,"col_table"
,"col_tr"
,"col_td"
,"col_thead"
,"col_tbody"
,"col_th"
,"col_ul"
,"col_ol"
,"col_dl"
,"col_script"
,"col_noscript"
,"col_style"
,"col_form"
,"col_select"
,"col_optgroup"
,"col_fieldset"
,"col_legend"
,"col_frameset"
,"col_frame"
,"col_noframes"
,"col_link");

	var formatdefaults = new Array(true,
true,
true,
true,
true,
false,
true,
true,
true,
true,
false,
false,
true,
true,
true,
true,
true,
true,
true,
true,
true,
false,
false,
false,
false,
false,
false,
true);

	var blocks = new Array();
	try {
		var prefsc = Components.classes["@mozilla.org/preferences-service;1"].
	                    getService(Components.interfaces.nsIPrefService);
		var prefs = prefsc.getBranch("extensions.viewformattedsource.formatting");
		var onoroff;
	  for (var x=0;x<formatelements.length;x++) {		
	  	try {
	  		var v = prefs.getBoolPref(formatelements[x]);
				onoroff = v;
			} catch (E) {
				onoroff = formatdefaults[x];
			}
			if (onoroff==true) {
				blocks.push(formatelements[x].toUpperCase().substring(4));
			}
		}	
	} catch (E) {
		alert('Returning defaults');		
		for (var x=0;x<formatelements.length;x++) {	
			if (formatdefaults[x]) blocks.push(formatelements[x]);
		}
	}
	return blocks;
}

	
	
	VPPSClass.indent=0;
	VPPSClass.currenttag="";	
	VPPSClass.blocknr=0;
	VPPSClass.wrapdone=false;
	VPPSClass.hostname="";
	VPPSClass.fullpath="";
	VPPSClass.pathname="";	
	VPPSClass.formattingarray = VPPS_getFormattingArray();
	VPPSClass.showexternalscripts = false;
	VPPSClass.queryi=null;
	VPPSClass.dominspector=false;
	VPPSClass.showcssinfo=true;
	VPPSClass.invisiblecharreplacement='';
	
	VPPSClass.prototype.doPrettyPrint = function(what) {
		//this.formattingarray = VPPS_getFormattingArray();
		var source="";
		if (what=="maindoc") {
			 source = window.content.document.getElementsByTagName("html")[0];
			 var host = window.content.location.hostname;
			 if (host == undefined) host="";
			 this.hostname = window.content.location.protocol+"//"+host;
			 this.fullpath = window.content.location.href;
			 this.pathname = window.content.location.pathname;
			 if (this.pathname.charAt(this.pathname.length-1)!='/') {
			 	 if (this.pathname.lastIndexOf('/')!=-1) {
			 	 		this.pathname = this.pathname.substring(0,this.pathname.lastIndexOf('/')+1);
			 	 } else
			 	 	this.pathname+='/';
			 	}	 			
			}
		else
		if (what=="frame") {
			 source = document.commandDispatcher.focusedWindow.document.getElementsByTagName("html")[0];		
			 var host = document.commandDispatcher.focusedWindow.content.location.hostname;
			 if (host == undefined) host = "";
		 this.hostname = document.commandDispatcher.focusedWindow.content.location.protocol+"//"+host;
			 this.fullpath = document.commandDispatcher.focusedWindow.content.location.href;
			 this.pathname = document.commandDispatcher.focusedWindow.content.location.pathname;
			 if (this.pathname.charAt(this.pathname.length-1)!='/') {
				 if (this.pathname.lastIndexOf('/')!=-1) {
				 		this.pathname = this.pathname.substring(0,this.pathname.lastIndexOf('/')+1);
				 } else
				 	this.pathname+='/';
			 }	 
		}
		if (what=="selection") {
			//var focusedWindow = document.commandDispatcher.focusedWindow.content;
			//var focusedWindow = window.content;
    	//code = focusedWindow.__proto__.getSelection.call(focusedWindow);
			source = document.commandDispatcher.focusedWindow.document.getElementsByTagName("html")[0];		
			 this.hostname = document.commandDispatcher.focusedWindow.content.location.protocol+"//"+document.commandDispatcher.focusedWindow.content.location.hostname;
			 this.pathname = document.commandDispatcher.focusedWindow.content.location.pathname;
			 this.fullpath = document.commandDispatcher.focusedWindow.content.location.href;
			 if (this.pathname.charAt(this.pathname.length-1)!='/') {
				 if (this.pathname.lastIndexOf('/')!=-1) {
				 		this.pathname = this.pathname.substring(0,this.pathname.lastIndexOf('/')+1);
				 } else
				 	this.pathname+='/';
			 }	     	
    	var code=document.commandDispatcher.focusedWindow.getSelection();    	    	
			sourcec = this.getSelectionHtml(code);			
			source=sourcec;
		}
		//var source=window._content.document.getElementsByTagName("html")[0];		
		this.createDocument(source);
	}
/*	
	function pleasewaitloaded() {
			window.content.document.open();
		  window.content.document.write("<html><body>"+this.vpps_message_pleasewait+"</body></html>");
			window.content.document.close();
	}
*/
	VPPSClass.vpps_error_nodominspector = "";
	VPPSClass.vpps_error_nostylesdefined = "";
	VPPSClass.vpps_error_nocssinfoavailableinthisview = "";
	VPPSClass.vpps_message_pleasewait = "";
	VPPSClass.vpps_message_cssinfo_thisdocument = "";
	VPPSClass.vpps_message_cssinfo_linenumber = "";
	VPPSClass.vpps_message_cssinfo_inlinestyle = "";
	VPPSClass.vpps_message_togglestickyness = "";
		
		
	VPPSClass.bluefontprototype = null;
	VPPSClass.hoverlinkprototype = null;
	VPPSClass.redfontprototype = null;
	VPPSClass.blackfontprototype = null;
	VPPSClass.texttableprototype = null;
	VPPSClass.commenttableprototype = null;
	VPPSClass.previewimagelinkprototype = null;
	VPPSClass.controldivprototype = null;
	VPPSClass.foldiconlinkprototype = null;

	VPPSClass.prototype.getAppID = function() {
		var id;
		if("@mozilla.org/xre/app-info;1" in Components.classes) {
			// running under Mozilla 1.8 or later
			id = Components.classes["@mozilla.org/xre/app-info;1"]
				.getService(Components.interfaces.nsIXULAppInfo).ID;
		} else {
			try {
				id = Components.classes["@mozilla.org/preferences-service;1"]
					.getService(Components.interfaces.nsIPrefBranch)
					.getCharPref("app.id");
			} catch(e) {
				// very old version
				dump(e);
			}
		}
		return id;
  	}

	VPPSClass.specialchar = new Array(/&/g,/</g,/>/g,/\"/g,//g,"","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","");
	VPPSClass.replacements = new Array("amp;","lt;","gt;","quot;","nbsp;","OElig;","oelig;","Scaron;","scaron;","Yuml;","circ;","tilde;","ndash;","mdash;","lsquo;","rsquo;","sbquo","ldquo;","rdquo;","bdquo;","dagger;","Dagger;","permil;","lsaquo;","rsaquo;","euro;","auml;","Auml;","ouml;","Ouml;","uuml;","Uuml;","nbsp;","cent;","&curren","brvbar;","uml;","para;","Agrave;","Acirc;","AElig;","Egrave;","Ecirc;","Igrave;","Icirc;","Ograve;","Ocirc;","Oslash;","Uacute;","agrave","acirc;","aelig;","egrave;","ecirc;","igrave;","icirc;","eth;","ograve;","ocirc;","oslash;","uacute;","thorn;","pound;","yen;","sect;","copy;","laquo;","macr;","plusmn;","sup3;","micro;","middot;","sup1;","raquo;","frac12;","iquest;","Aacute;","Atilde;","Aring;","Ccedil;","Eacute;","Euml;","Iacute;","Iuml;","Ntilde;","Oacute;","Otilde;","times;","Ugrave;","Ucirc;","Yacute;","szlig;","aacute;","atilde;","aring;","ccedil;","eacute;","euml;","iacute;","iuml;","ntilde;","oacute;","otilde;","divide;","ugrave;","ucirc;","yacute;","yuml;");

	VPPSClass.prototype.createDocument = function(source) {
		// load preferences

		var xulwindowname = "window.xul";

		const FIREFOX_ID   = "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}";
		const SEAMONKEY_ID = "{92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}";
		var id = this.getAppID();
		if (id == FIREFOX_ID && "@mozilla.org/xre/app-info;1" in Components.classes) {
			var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
				.getService(Components.interfaces.nsIXULAppInfo);
			var versionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"]
				.getService(Components.interfaces.nsIVersionComparator);
			if(versionChecker.compare(appInfo.version, "3.0a") >= 0) {
				// running under Firefox 3.0a or later
				xulwindowname="window_v3.xul";
			}
			else if(versionChecker.compare(appInfo.version, "2.0") >= 0) {
				// running under Firefox 2.0 or later
				xulwindowname="window_v2.xul";
			}
			else if(versionChecker.compare(appInfo.version, "1.5") >= 0) {
				// running under Firefox 1.5 or later
				xulwindowname="window.xul";
			}
		}
		else if (id == FIREFOX_ID) {
			xulwindowname="window_v1.xul";
		}
		else if (id == SEAMONKEY_ID) {
			xulwindowname="window_sm.xul";
		}

		this.formattingarray = VPPS_getFormattingArray();
		// read some strings
		var stringBundle = srGetStrBundle("chrome://vpps/locale/vpps.properties");
		this.vpps_error_nodominspector = stringBundle.GetStringFromName("error.nodominspectorinstalled");
		this.vpps_error_nostylesdefined = stringBundle.GetStringFromName("error.nostylesdefined");
		this.vpps_error_nocssinfoavailableinthisview = stringBundle.GetStringFromName("error.nocssinfoavailableinthisview");
		this.vpps_message_pleasewait = stringBundle.GetStringFromName("message.generatingsource");		
		this.vpps_message_cssinfo_thisdocument = stringBundle.GetStringFromName("message.cssinfo.thisdocument");
		this.vpps_message_cssinfo_linenumber = stringBundle.GetStringFromName("message.cssinfo.linenumber");
		this.vpps_message_cssinfo_inlinestyle = stringBundle.GetStringFromName("message.cssinfo.inlinestyle");
		this.vpps_message_togglestickyness = stringBundle.GetStringFromName("message.togglestickyness");
		var prefsc = Components.classes["@mozilla.org/preferences-service;1"].
	                    getService(Components.interfaces.nsIPrefService);	                    
		var prefs = prefsc.getBranch("extensions.viewformattedsource.formatting");
		try {
	  	this.showexternalscripts = prefs.getBoolPref('showexternalscripts');
	  } catch (E) {
	  	this.showexternalscripts = false;
	  }
	  try {
	  	this.showcssinfo = prefs.getBoolPref('showcssinfo');
	  } catch (E) {
	  	this.showcssinfo = true;
	  }
	  try {
	  	if (prefs.getBoolPref('replaceinvisiblechar')) this.invisiblecharreplacement=''; else this.invisiblecharreplacement='';
	  } catch (E) {
	  	this.invisiblecharreplacement='';
	  }	  
		var next = source;		
		// create dom inspector
		try {
			var inspector = Components.classes["@mozilla.org/inspector/dom-utils;1"].getService();
			this.queryi = inspector.QueryInterface(Components.interfaces.inIDOMUtils);
			this.dominspector=true;
		} catch (E) {
			this.dominspector=false;
		}
		var sourcewin = window.openDialog("chrome://vpps/content/"+xulwindowname, stringBundle.GetStringFromName("mainwindow.caption"), "chrome,dialog=0,resizable=1,left=30,top=30,width=1000,height=600");
		if (!sourcewin.document.open) {
			sourcewin.close();
			sourcewin = window.openDialog("chrome://vpps/content/"+xulwindowname, stringBundle.GetStringFromName("mainwindow.caption"), "chrome,dialog=0,resizable=1,left=30,top=30,width=1000,height=600");
		}
		sourcewin.document.open();
		sourcewin.document.write('<html><head><title>'+stringBundle.GetStringFromName("mainwindow.caption")+'</title></head><body><font face="Lucida Console","Courier New",Courier,monospace size="2"></font></body></html>');
		sourcewin.document.close();
		
			//var sourcewin = window.open("about:blank", "Source", "toolbar=1,menubar=1,resizable=1,left=30,top=30,width=800,height=600");
			//var sourcewin = window.open("", "Source", "resizable=1,left=30,top=30,width=1000,height=600");
		
		this.specialchar = new Array(/&/g,/</g,/>/g,/\"/g,//g,"","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","");
		this.replacements = new Array("amp;","lt;","gt;","quot;","nbsp;","OElig;","oelig;","Scaron;","scaron;","Yuml;","circ;","tilde;","ndash;","mdash;","lsquo;","rsquo;","sbquo","ldquo;","rdquo;","bdquo;","dagger;","Dagger;","permil;","lsaquo;","rsaquo;","euro;","auml;","Auml;","ouml;","Ouml;","uuml;","Uuml;","nbsp;","cent;","&curren","brvbar;","uml;","para;","Agrave;","Acirc;","AElig;","Egrave;","Ecirc;","Igrave;","Icirc;","Ograve;","Ocirc;","Oslash;","Uacute;","agrave","acirc;","aelig;","egrave;","ecirc;","igrave;","icirc;","eth;","ograve;","ocirc;","oslash;","uacute;","thorn;","pound;","yen;","sect;","copy;","laquo;","macr;","plusmn;","sup3;","micro;","middot;","sup1;","raquo;","frac12;","iquest;","Aacute;","Atilde;","Aring;","Ccedil;","Eacute;","Euml;","Iacute;","Iuml;","Ntilde;","Oacute;","Otilde;","times;","Ugrave;","Ucirc;","Yacute;","szlig;","aacute;","atilde;","aring;","ccedil;","eacute;","euml;","iacute;","iuml;","ntilde;","oacute;","otilde;","divide;","ugrave;","ucirc;","yacute;","yuml;");

		this.bluefontprototype = document.createElement("i");
		this.hoverlinkprototype = document.createElement("a");
		this.hoverlinkprototype.setAttribute("onmouseover","hilite(this.getAttribute('_vpps_id'))");
		this.hoverlinkprototype.setAttribute("onmouseout","lolite(this.getAttribute('_vpps_id'))");
		this.hoverlinkprototype.href="javascript:void()";
		this.redfontprototype = document.createElement("b");
		this.blackfontprototype = document.createElement("u");
		this.texttableprototype = document.createElement("table");
		this.texttableprototype.width="500"
		var tr = document.createElement("tr");
		var td = document.createElement("td");	
		td.setAttribute("style","font-size:11px");		
		var pre = document.createElement('pre');
		pre.width=100;
		td.appendChild(pre);
		tr.appendChild(td);
		this.texttableprototype.appendChild(tr);
		// comment table
		this.commenttableprototype = document.createElement("table");
		this.commenttableprototype.width="500"
		var trc = document.createElement("tr");
		var tdc = document.createElement("td");	
		tdc.setAttribute("style","font-size:11px;color:#888888");		
		trc.appendChild(tdc);
		this.commenttableprototype.appendChild(trc);
		// view image link
		this.previewimagelinkprototype = document.createElement("a");
		this.previewimagelinkprototype.href="javascript:void()";
		this.previewimagelinkprototype.setAttribute("onMouseOver","showimg(this.getAttribute('imgsrc'));");
		this.previewimagelinkprototype.setAttribute("onMouseOut","hideimg();");
		// control div
		this.controldivprototype = document.createElement('div');
		this.controldivprototype.setAttribute("style", "float: left;margin-top:4px;margin-right:7px;");
		// fold icon link
		this.foldiconlinkprototype = document.createElement('a');			
		this.foldiconlinkprototype.setAttribute("href","javascript:void();");
		this.foldiconlinkprototype.setAttribute("onclick","unfold(this.getAttribute('blocknr'))");
		this.foldiconlinkprototype.setAttribute("onmouseover","hilite(this.getAttribute('blocknr'))");
		this.foldiconlinkprototype.setAttribute("onmouseout","lolite(this.getAttribute('blocknr'))");

		//sourcewin.document.write("<html><body><font face=arial size=2></font></body></html>");
		var ftarget = sourcewin.document.getElementsByTagName("font")[0];	
		//ftarget = document.commandDispatcher.focusedWindow.content.document.createElement("font");
		//sourcewin.document.close();

		//var ftarget = document.createElement("font");
		window.status=this.vpps_message_pleasewait;
		//this.createJavascriptFunctions();		
		//this.createCSS();
		this.wrapdone=false;
		this.indent=0;
		this.currenttag="";
		this.blocknr=0;
		ftarget = this.printNode(source,ftarget);
		this.indent++;
		this.printChildren(next,ftarget);
		this.indent--;
		ftarget = this.printFinalNode(source, ftarget);
		var data=ftarget.innerHTML;		
		/*sourcewin.document.close();
		sourcewin.document.open();
	  sourcewin.document.write("<html><head><title>Formatted source</title>"+this.createJavascriptFunctions()+this.createCSS()+"</head><body><span id='styledata' style='display:none;border:1px;border-style:solid;background-color:#eeeeee;position:absolute;top:5px;left:5px;'><span id='previewimg' style='display:none;border:1px;border-style:solid;background-color:#eeeeee;position:absolute;top:5px;left:5px;'></span><font face=arial size=2>"+data+"</font></body></html>");
	  sourcewin.document.close();*/
//	  window.status = sourcewin + sourcewin.document;
		//sourcewin.close();
	  sourcewin = window.openDialog("chrome://vpps/content/"+xulwindowname, stringBundle.GetStringFromName("mainwindow.caption"), "chrome,dialog=0,resizable=1,left=30,top=30,width=1000,height=600","<html><head><title>"+stringBundle.GetStringFromName("mainwindow.caption")+"</title>"+this.createJavascriptFunctions()+this.createCSS()+"</head><body><span id=\"styledata\" style=\"display:none;padding:2px;border:1px;border-style:solid;background-color:#ffffe7;position:absolute;top:5px;left:5px;font-family:'Lucida Console', 'Courier New', Courier, monospace;font-size:10px;\"></span><span id='previewimg' style='display:none;border:1px;border-style:solid;background-color:#eeeeee;position:absolute;top:5px;left:5px;'></span><font face='Lucida Console','Courier New',Courier,monospace size='2'>"+data+"</font><div style=\"Height:150px;\">&nbsp;</div></body></html>");
	  window.status="";
	  //sourcewin=window.open("","Formatted Source","");
	  //source.document.write("<html><head><title>Formatted source</title>"+this.createJavascriptFunctions()+this.createCSS()+"</head><body><span id='previewimg' style='display:none;border:1px;border-style:solid;background-color:#eeeeee;position:absolute;top:5px;left:5px;'></span><font face=arial size=2>"+data+"</font></body></html>");
	}
	

	
	VPPSClass.prototype.createFromInlineDocument = function(source,what) {
		//this.formattingarray = VPPS_getFormattingArray();
		if (what=="maindoc") {			 		
			 this.hostname = window.content.location.protocol+"//"+window.content.location.hostname;
			 this.fullpath = window.content.location.href;
			 this.pathname = window.content.location.pathname;
			 if (this.pathname.charAt(this.pathname.length-1)!='/') {
			 	 if (this.pathname.lastIndexOf('/')!=-1) {
			 	 		this.pathname = this.pathname.substring(0,this.pathname.lastIndexOf('/')+1);
			 	 } else
			 	 	this.pathname+='/';
			 	}	 
			}
		else
		if (what=="frame") {
			this.hostname = document.commandDispatcher.focusedWindow.document.location.protocol+"//"+document.commandDispatcher.focusedWindow.document.location.hostname;
			this.fullpath = document.commandDispatcher.focusedWindow.document.location.href;
			this.pathname = document.commandDispatcher.focusedWindow.document.location.pathname;
			if (this.pathname.charAt(this.pathname.length-1)!='/') {
				 if (this.pathname.lastIndexOf('/')!=-1) {
				 		this.pathname = this.pathname.substring(0,this.pathname.lastIndexOf('/')+1);
				 } else
				 	this.pathname+='/';
			}	 
		}
			  this.createDocument(source);
	}
	
	VPPSClass.prototype.doInlineMode = function(what) {
		if (what=="frame")
			source = document.commandDispatcher.focusedWindow.document;		
		if (what=="maindoc")
			 source = window.content.document;					
		this.scanChildren(source,what);
	}	
	
	VPPSClass.prototype.getInlineModeArray = function() {
		var elements = new Array('table','tr','td','th','div','span');
		var defaults = new Array(true, false, false, false, true, true);
		var blocks = new Array();
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefService);
		prefs = prefs.getBranch("extensions.viewformattedsource.inlinemode");
		var onoroff;
		for (var x=0;x<elements.length;x++) {		
  			try {
	  			var v = prefs.getBoolPref(elements[x]);
				onoroff = v;
			} catch (E) {
				onoroff = defaults[x];
			}
			if (onoroff==true) {
				blocks.push(elements[x]);
			}
		}	
		return blocks;
	}
	
	VPPSClass.prototype.scanChildren = function(source,on) {
		if (source.getElementById('__vpps_0')) return;	
		const linestyles = new Array("solid red 2px","solid blue 2px","dotted red 2px","dotted blue 2px","solid #c0c0c0 2px","dotted #c0c0c0 2px");
		const blockelements = this.getInlineModeArray();	
		var head = source.getElementsByTagName('HEAD');
		/*script = source.createElement('script');
		script.src="chrome://vpps/content/vpps.js";
		script.type="text/javascript";
		head[0].appendChild(script);		
		oscript = source.createElement('script');
		oscript.src="chrome://vpps/content/options.js";
		oscript.type="text/javascript";
		head[0].appendChild(oscript);					*/
		var nr=0;
		var currentstyle=0;
		for (var x = 0; x<blockelements.length; x++) {
			var p = source.getElementsByTagName(blockelements[x]);
	   	for(var i=0; i<p.length; i++){
	    	var node = p[i];
	    	if (node.id.indexOf('__vpps_')!=-1) { continue};
	    	span = source.createElement('div');   
	    	var id = '__vpps_'+nr;
	    	nr++;
	    	span.id=id;
	    	img = source.createElement('img');
	    	img.src='chrome://vpps/skin/source.png';	   
	    	var style = node.getAttribute('style');
	    	if (style==null) style='';
	    	img.setAttribute("title","Type: "+node.tagName+", ID: "+node.id+", Style: "+style+", Class: "+node.className); 		    	
	    	var boldstyle="solid red 4px";
	    	img.setAttribute("onMouseOver", "this.parentNode.style.border='"+boldstyle+"';");
	    	img.setAttribute("onMouseOut", "this.parentNode.style.border='"+linestyles[currentstyle]+"';");
	    	img.setAttribute("vpps","true");
	    	img.setAttribute("targetid",id);
	    	img.setAttribute("win",on);
	    	img.setAttribute("style","cursor:pointer;");
	    	img.border=0;
	    	span.appendChild(img);
	    	span.setAttribute('style','z-index:1000000;'); 	
	    	span.style.border=linestyles[currentstyle];	    	
	    	currentstyle++;
	    	if (currentstyle>=linestyles.length) currentstyle=0;
	      span.appendChild(node.cloneNode(true));
	      node.parentNode.replaceChild(span,node);      
	      if (node.tagName=='DIV') { i++;} // skip node
			}
		}
	}	
	
	VPPSClass.prototype.removeInlineMode = function(what) {
		if (what=="frame")
			source = document.commandDispatcher.focusedWindow.document;		
		if (what=="maindoc")
			 source = window.content.document;					
		this.removeInlineModeDivs(source,what);
	}		
	
	VPPSClass.prototype.removeInlineModeDivs = function(source,on) {
		
		if (!source.getElementById('__vpps_0')) return;
		
		var nr=0;
		var currentstyle=0;		
		var removed=false;
		do {
			var p = source.getElementsByTagName("DIV");
			removed=false;			
		  for(var i=0; i<p.length; i++){
		   	var node = p[i];
		   	if (node.id.indexOf('__vpps_')==-1) { continue};	  	    	
		   	removed=true;
		    node.parentNode.replaceChild(node.firstChild.nextSibling,node);      	      
			}		
		} while (removed==true);
	}	
		
	
const VPPSObject = new VPPSClass();	


function onLoadViewFormattedSource() {
	//document.commandDispatcher.focusedWindow = content;
	var browser = document.getElementById('content');
	try {
		browser.contentDocument.open("text/html");
	} catch (E) {
		alert('Error opening document '+browser.contentDocument+", message "+E);
	}
	try {
		window.content.document.write(window.arguments[0]);
	} catch (E) {
		window.content.document.write('Error writing content');
	}
	window.content.document.close();
}
	
	////////////////////////////////////////////////////////////////////////////////
// helper to get a path like FIXptr, but with an array instead of the "tumbler" notation
// see FIXptr: http://lists.w3.org/Archives/Public/www-xml-linking-comments/2001AprJun/att-0074/01-NOTE-FIXptr-20010425.htm
function VPPS_getPath(ancestor, node)
{	
  var n = node;
  var p = n.parentNode;
  if (n == ancestor || !p)
    return null;
  var path = new Array();
  if (!path)
    return null;
  do {
    for (var i = 0; i < p.childNodes.length; i++) {
      if (p.childNodes.item(i) == n) {
        path.push(i);
        break;
      }
    }
    n = p;
    p = n.parentNode;
  } while (n != ancestor && p);
  return path;
}

	VPPSClass.prototype.getSelectionHtml = function(selection) {		
// code taken from viewPartialSource.js from toolkit.jar	
const MARK_SELECTION_START = '\u200B\u200B\u200B\u200B\u200B';
const MARK_SELECTION_END = '\u200B\u200B\u200B\u200B\u200B';
//const MARK_SELECTION_START = '[[selstart]]';
//const MARK_SELECTION_END = '[[selend]]';
const gViewSourceCSS = 'resource://gre/res/viewsource.css';
const NS_XHTML = 'http://www.w3.org/1999/xhtml';		
		  var range = selection.getRangeAt(0);		  
  var ancestorContainer = range.commonAncestorContainer;
  var doc = ancestorContainer.ownerDocument;

  var startContainer = range.startContainer;
  var endContainer = range.endContainer;
  var startOffset = range.startOffset;
  var endOffset = range.endOffset;

  // let the ancestor be an element
  if (ancestorContainer.nodeType == Node.TEXT_NODE ||
      ancestorContainer.nodeType == Node.CDATA_SECTION_NODE)
    ancestorContainer = ancestorContainer.parentNode;

  // for selectAll, let's use the entire document, including <html>...</html>
  // @see DocumentViewerImpl::SelectAll() for how selectAll is implemented
  try {
    if (ancestorContainer == doc.body)
      ancestorContainer = doc.documentElement;
  } catch (e) { }

  // each path is a "child sequence" (a.k.a. "tumbler") that
  // descends from the ancestor down to the boundary point
  var startPath = VPPS_getPath(ancestorContainer, startContainer);
  var endPath = VPPS_getPath(ancestorContainer, endContainer);

  // clone the fragment of interest and reset everything to be relative to it
  // note: it is with the clone that we operate from now on
  ancestorContainer = ancestorContainer.cloneNode(true);
  startContainer = ancestorContainer;
  endContainer = ancestorContainer;
  var i;
  
  for (i = startPath ? startPath.length-1 : -1; i >= 0; i--) {
    startContainer = startContainer.childNodes.item(startPath[i]);
  }
  for (i = endPath ? endPath.length-1 : -1; i >= 0; i--) {
    endContainer = endContainer.childNodes.item(endPath[i]);
  }

  // add special markers to record the extent of the selection
  // note: |startOffset| and |endOffset| are interpreted either as
  // offsets in the text data or as child indices (see the Range spec)
  // (here, munging the end point first to keep the start point safe...)
  var tmpNode;
  if (endContainer.nodeType == Node.TEXT_NODE ||
      endContainer.nodeType == Node.CDATA_SECTION_NODE) {
    // do some extra tweaks to try to avoid the view-source output to look like
    // ...<tag>]... or ...]</tag>... (where ']' marks the end of the selection).
    // To get a neat output, the idea here is to remap the end point from:
    // 1. ...<tag>]...   to   ...]<tag>...
    // 2. ...]</tag>...  to   ...</tag>]...
    if ((endOffset > 0 && endOffset < endContainer.data.length) ||
        !endContainer.parentNode || !endContainer.parentNode.parentNode)
      endContainer.insertData(endOffset, MARK_SELECTION_END);
    else {
      tmpNode = doc.createTextNode(MARK_SELECTION_END);
      endContainer = endContainer.parentNode;
      if (endOffset == 0)
        endContainer.parentNode.insertBefore(tmpNode, endContainer);
      else
        endContainer.parentNode.insertBefore(tmpNode, endContainer.nextSibling);
    }
  }
  else {
    tmpNode = doc.createTextNode(MARK_SELECTION_END);
    endContainer.insertBefore(tmpNode, endContainer.childNodes.item(endOffset));
  }

  if (startContainer.nodeType == Node.TEXT_NODE ||
      startContainer.nodeType == Node.CDATA_SECTION_NODE) {
    // do some extra tweaks to try to avoid the view-source output to look like
    // ...<tag>[... or ...[</tag>... (where '[' marks the start of the selection).
    // To get a neat output, the idea here is to remap the start point from:
    // 1. ...<tag>[...   to   ...[<tag>...
    // 2. ...[</tag>...  to   ...</tag>[...
    if ((startOffset > 0 && startOffset < startContainer.data.length) ||
        !startContainer.parentNode || !startContainer.parentNode.parentNode ||
        startContainer != startContainer.parentNode.lastChild)
      startContainer.insertData(startOffset, MARK_SELECTION_START);
    else {
      tmpNode = doc.createTextNode(MARK_SELECTION_START);
      startContainer = startContainer.parentNode;
      if (startOffset == 0)
        startContainer.parentNode.insertBefore(tmpNode, startContainer);
      else
        startContainer.parentNode.insertBefore(tmpNode, startContainer.nextSibling);
    }
  }
  else {
    tmpNode = doc.createTextNode(MARK_SELECTION_START);
    startContainer.insertBefore(tmpNode, startContainer.childNodes.item(startOffset));
  }

	return ancestorContainer;
	}
	// end code taken from viewPartialSource.js
	
	

VPPSClass.prototype.isInArray = function(array, o) {
	for (var x=0;x<array.length;x++) { if (array[x]==o) return true;}
	return false;
}

VPPSClass.prototype.toHex = function(dec) {
	var hexnrs="0123456789abcdef";
  var hex = hexnrs.substr(dec&15,1);
  while(dec>15) {dec>>=4;hex=hexnrs.substr(dec&15,1)+hex;}
  if (hex.length<2) hex = "0"+hex;
  return hex;
}


VPPSClass.prototype.replaceWithHexValues = function(style) {
	// rgb(0, 51, 153);
	var pattern=/rgb\(([0-9]+)\s*,\s*([0-9]+)\s*,\s*([0-9]+)\s*\)/;
	do {
		var result = pattern.exec(style);
		if (result) {
			var red = result[1];
			var green = result[2];
			var blue = result[3];
			var hex = "#"+this.toHex(red)+this.toHex(green)+this.toHex(blue);
			style = style.replace(result[0],hex);
		}
	} while (result);
	return style;
}

VPPSClass.prototype.computeStyle = function(o) {
	if (this.dominspector==false) return this.vpps_error_nodominspector;
	var rules = this.queryi.getCSSStyleRules(o);
	if (!rules) return this.vpps_error_nocssinfoavailableinthisview;
	var status="";
	var nothing=true;
	var itemlist = new Array();
	if (o.style && o.style.length>0) {
		status+="<div class=\"cssheader\">"+this.vpps_message_cssinfo_inlinestyle+"</div>&nbsp;";
		var csstext = o.style.cssText;
		csstext = this.replaceWithHexValues(csstext);
		csstext = csstext.replace(/;/g,";<br>&nbsp;");
		csstext = csstext.replace(/{/g,"{<br>&nbsp;");
		//csstext = this.replaceWithHexValues(csstext);
		status+=csstext;
		nothing=false;
		/*for (var y=0;y<o.style.length;y++) {
				var item = o.style.item(y);
				var bold="";
				var unbold="";
				if (!this.isInArray(itemlist, item)) {
					bold="<b style=\\'font-weight:bold\\'>";
					endbold="</b>";
					itemlist.push(item);
				}
				status+=bold+item+": "+o.style.getPropertyValue(item)+endbold+"<br>";
			}*/
	}
	for (var x=rules.Count()-1;x>=0;x--) {
		var href=rules.GetElementAt(x).parentStyleSheet.href;
		if (href && href.indexOf("resource:")!=0 && href.indexOf("about:")!=0) {
			if (href==this.fullpath) href=this.vpps_message_cssinfo_thisdocument; else {
				var idx=href.indexOf(this.hostname);
				if (idx==0) href=href.substring(idx+this.hostname.length);
				idx = href.indexOf(this.pathname);
				if (idx==0) href=href.substring(idx+this.pathname.length);			
			}
			status += "<div class=\"cssheader\" align=\"right\"><span style=\"float:left\">" + href + "</span>&nbsp;&middot;&nbsp;"+this.vpps_message_cssinfo_linenumber+" "+this.queryi.getRuleLine(rules.GetElementAt(x)) + "<br></div>";
			var csstext = rules.GetElementAt(x).cssText;
			csstext = this.replaceWithHexValues(csstext);
			csstext = csstext.replace(/;/g,";<br>&nbsp;");
			csstext = csstext.replace(/{/g,"{<br>&nbsp;");			
			status += "<table border=0><tr><td class=\"csstext\">"+csstext+"</td></tr></table>";
			nothing=false;
			/*for (var y=0;y<rules.GetElementAt(x).style.length;y++) {
				var item = rules.GetElementAt(x).style.item(y);
				var bold="";
				var unbold="";
				if (!this.isInArray(itemlist, item)) {
					bold="<b style=\\'font-weight:bold\\'>";
					endbold="</b>";
					itemlist.push(item);
				}
				status+=bold+item+": "+rules.GetElementAt(x).style.getPropertyValue(item)+" "+rules.GetElementAt(x).style.getPropertyPriority(item)+endbold+"<br>";
			}*/
		}
	}
	if (nothing==true) status=this.vpps_error_nostylesdefined;
	status+="<br><br><div style=\"background-color:#888888;width:100%\"><font style=\"size:10px;color:#ffffff\">"+this.vpps_message_togglestickyness+"</font></div>";
	return status;
}

window.addEventListener("click", function(event) { if (event.button==0 && event.explicitOriginalTarget.tagName=='IMG' && event.explicitOriginalTarget.getAttribute('vpps') != undefined) { VPPSObject.createFromInlineDocument(document.commandDispatcher.focusedWindow.document.getElementById(event.explicitOriginalTarget.getAttribute('targetid')).firstChild.nextSibling, event.explicitOriginalTarget.getAttribute('win')   ); } },true);	